/*
 * Copyright (C) 2008 Gauvain Pocentek <gpocentek@linutop.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h>

#include <gtk/gtk.h>
#include <libxfce4util/libxfce4util.h>

#include "libappstarter/as.h"

#define PLUGIN "custom"

gchar *command;

gchar *
get_cmd()
{
    return command;
}

static void
entry_changed(GtkWidget *entry, gpointer *data)
{
    XfceRc *rc;

    command = strdup (gtk_entry_get_text (GTK_ENTRY (entry)));
    rc = as_rc_open(FALSE);
    if (!rc)
        return;
    xfce_rc_set_group(rc, PLUGIN);
    xfce_rc_write_entry(rc, "command", command);
    xfce_rc_close(rc);
}

gchar *
read_command()
{
    XfceRc *rc;

    rc = as_rc_open (TRUE);
    if (!rc)
        return "";

    gchar *u;
    xfce_rc_set_group(rc, PLUGIN);
    u = strdup (xfce_rc_read_entry (rc, "command", ""));

    xfce_rc_close(rc);
    return u;
}

GtkWidget *
get_config_widget()
{
    GtkWidget *label, *hbox, *entry;

    hbox = gtk_hbox_new (FALSE, 2);
    label = gtk_label_new (_("Enter a command: "));
    gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);
    gtk_widget_show (label);

    command = read_command();
    entry = gtk_entry_new ();
    gtk_entry_set_text (GTK_ENTRY (entry), command);
    gtk_box_pack_start (GTK_BOX (hbox), entry, TRUE, TRUE, 2);
    gtk_widget_show (entry);

    g_signal_connect (G_OBJECT (entry), "changed",
        G_CALLBACK (entry_changed), NULL);

    return hbox;
}

void
free_all()
{
    g_free(command);
}
